VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "SYNC_Protocol"
   ClientHeight    =   5175
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4455
   LinkTopic       =   "Form1"
   ScaleHeight     =   5175
   ScaleWidth      =   4455
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Btn_AddNode 
      Caption         =   "Add Node"
      Height          =   375
      Left            =   2880
      TabIndex        =   19
      Top             =   720
      Width           =   1455
   End
   Begin VB.CommandButton Btn_Initial 
      Caption         =   "Initial Master"
      Height          =   375
      Left            =   2880
      TabIndex        =   18
      Top             =   240
      Width           =   1455
   End
   Begin VB.Frame Pal_SYNC 
      Caption         =   "SYNC Protocol"
      Height          =   3855
      Left            =   120
      TabIndex        =   5
      Top             =   1200
      Width           =   4215
      Begin VB.CommandButton Btn_SendSYNC 
         Caption         =   "Send SYNC"
         Height          =   375
         Left            =   2520
         TabIndex        =   11
         Top             =   1080
         Width           =   1575
      End
      Begin VB.TextBox Text_SYNCTimes 
         Height          =   375
         Left            =   1440
         MaxLength       =   10
         TabIndex        =   10
         Text            =   "00"
         Top             =   1080
         Width           =   855
      End
      Begin VB.TextBox Text_SYNCID 
         Height          =   375
         Left            =   1440
         MaxLength       =   3
         TabIndex        =   9
         Text            =   "80"
         Top             =   240
         Width           =   855
      End
      Begin VB.CommandButton Btn_SYNCID 
         Caption         =   "Change SYNC ID"
         Height          =   375
         Left            =   2520
         TabIndex        =   8
         Top             =   240
         Width           =   1575
      End
      Begin VB.ListBox List_SYNCID 
         Height          =   2010
         ItemData        =   "Form1.frx":0000
         Left            =   120
         List            =   "Form1.frx":0002
         TabIndex        =   7
         Top             =   1560
         Width           =   3975
      End
      Begin VB.TextBox Text_SYNCTimer 
         Height          =   375
         Left            =   240
         MaxLength       =   5
         TabIndex        =   6
         Text            =   "1000"
         Top             =   1080
         Width           =   855
      End
      Begin VB.Label Label5 
         Caption         =   "Send Times"
         Height          =   255
         Left            =   1440
         TabIndex        =   14
         Top             =   840
         Width           =   1095
      End
      Begin VB.Label Label4 
         Caption         =   "SYNC ID (hex)"
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   360
         Width           =   1215
      End
      Begin VB.Label Label7 
         Caption         =   $"Form1.frx":0004
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   840
         Width           =   975
      End
   End
   Begin VB.CommandButton Btn_Remove 
      Caption         =   "Remove Node"
      Height          =   375
      Left            =   2880
      TabIndex        =   4
      Top             =   720
      Width           =   1455
   End
   Begin VB.CommandButton Btn_Shutdown 
      Caption         =   "Shutdown"
      Height          =   375
      Left            =   2880
      TabIndex        =   3
      Top             =   240
      Width           =   1455
   End
   Begin VB.ComboBox Combo_Node 
      Height          =   315
      ItemData        =   "Form1.frx":0013
      Left            =   1080
      List            =   "Form1.frx":0194
      TabIndex        =   2
      Top             =   840
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Baud 
      Height          =   315
      ItemData        =   "Form1.frx":047F
      Left            =   1080
      List            =   "Form1.frx":049B
      TabIndex        =   1
      Top             =   480
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Board 
      Height          =   315
      ItemData        =   "Form1.frx":0501
      Left            =   1080
      List            =   "Form1.frx":0535
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Node ID"
      Height          =   255
      Left            =   120
      TabIndex        =   17
      Top             =   840
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "Baud Rate"
      Height          =   255
      Left            =   120
      TabIndex        =   16
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Board No"
      Height          =   255
      Left            =   120
      TabIndex        =   15
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

    Dim Board As Byte
    Dim Port As Byte
    Dim BAUD As Byte
    Dim Node As Byte

    Const BlockMode As Byte = 1

    Dim IsAdd(128) As Byte

    Dim DelayTime As Integer
    Dim ret As Integer
    Dim errstr As String

Private Sub UpdataList()
    Dim a_SyncId(5) As Integer, a_Timer(5) As Integer
    Dim a_Times(5) As Long
    Dim i As Integer

    Call List_SYNCID.Clear

    ret = CPM_GetCyclicSYNCInfo(Board, Port, a_SyncId(0), a_Timer(0), a_Times(0), BlockMode)
    If ret = 0 Then
        Dim Temp_Str As String

        For i = 0 To 4
            If a_SyncId(i) = 0 Then
                Exit For
            End If

            Temp_Str = "SYNC: " + Right("000" + Hex(a_SyncId(i)), 3) + " , Timer: " + Str(a_Timer(i)) + " , Times: " + Str(a_Times(i))
            List_SYNCID.AddItem (Temp_Str)
        Next
    End If
End Sub
    
Private Sub Btn_AddNode_Click()
    ret = CPM_AddNode(Board, Port, Node, 1, DelayTime, 200, BlockMode)
    If ret <> 0 Then
        errstr = "AddNode Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = False
        Btn_Remove.Enabled = True
        Combo_Node.Enabled = False

        Pal_SYNC.Enabled = True

    End If
End Sub

Private Sub Btn_Initial_Click()

    ret = CPM_InitMaster(Board, Port, 0, BAUD, BlockMode)
    If ret <> 0 Then
        errstr = "Initial Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Combo_Board.Enabled = False
        Combo_Baud.Enabled = False
        Combo_Node.Enabled = True

        Btn_Initial.Enabled = False
        Btn_Initial.Visible = False
        Btn_Shutdown.Enabled = True

        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
    End If
End Sub

Private Sub Btn_Remove_Click()
    ret = CPM_RemoveNode(Board, Port, Node, BlockMode)
    If ret <> 0 Then
        errstr = "RemoveNode Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Btn_Remove.Enabled = False
        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
        Combo_Node.Enabled = True

        Pal_SYNC.Enabled = False

    End If
End Sub

Private Sub Btn_SendSYNC_Click()
    Dim SyncId As Integer, tTimer As Integer
    Dim tTimes As Long

    SyncId = Val("&H" + Text_SYNCID.Text)
    tTimer = Val(Trim(Text_SYNCTimer.Text))
    tTimes = Val(Trim(Text_SYNCTimes.Text))

    ret = CPM_SendSYNCMsg(Board, Port, SyncId, tTimer, tTimes, BlockMode)
    If ret <> 0 Then
        errstr = "SendSYNCMsg Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Call UpdataList
    End If
End Sub

Private Sub Btn_Shutdown_Click()
    ret = CPM_ShutdownMaster(Board, Port)
    If ret <> 0 Then
        errstr = "Shutdown Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Combo_Board.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Btn_Initial.Enabled = True
        Btn_Initial.Visible = True
        Btn_Shutdown.Enabled = False

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = True
        Btn_Remove.Enabled = False

        Pal_SYNC.Enabled = False
    End If
End Sub

Private Sub Btn_SYNCID_Click()
    Dim SyncId As Integer

    SyncId = Val("&H" + Text_SYNCID.Text)

    ret = CPM_ChangeSYNCID(Board, Port, Node, SyncId, BlockMode)
    If ret <> 0 Then
        errstr = "ChangeSYNCID Error, = " + Str(ret)
        MsgBox (errstr)
    End If

    ret = CPM_GetSYNCID(Board, Port, Node, SyncId, BlockMode)
    If ret = 0 Then
        Text_SYNCID.Text = Hex(SyncId)
    End If
End Sub

Private Sub Combo_Baud_LostFocus()
    BAUD = Combo_Baud.ListIndex
    
    Select Case (BAUD)
        Case 0
            DelayTime = 15
        Case 1
            DelayTime = 7
        Case 2
            DelayTime = 3
        Case 3
        Case 4
            DelayTime = 1
        Case 5
        Case 6
        Case 7
            DelayTime = 0
    End Select
End Sub

Private Sub combo_board_LostFocus()
    Board = (Combo_Board.ListIndex)
End Sub

Private Sub Combo_Node_LostFocus()
    Node = Combo_Node.ListIndex + 1
End Sub

Private Sub Form_Load()
    Dim i As Integer

    Board = 0
    Port = 1
    BAUD = 0
    Node = 1

    Combo_Board.Enabled = True
    Combo_Baud.Enabled = True
    Combo_Node.Enabled = False

    Combo_Board.ListIndex = 0
    Combo_Baud.ListIndex = 0
    Combo_Node.ListIndex = 0

    Btn_AddNode.Enabled = False
    Btn_AddNode.Visible = True
    Btn_Remove.Enabled = False

    Pal_SYNC.Enabled = False

    For i = 0 To 128
        IsAdd(i) = 0
    Next
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Call CPM_ShutdownMaster(Board, Port)
End Sub

